module("luci.coredns.api",package.seeall)
bin=require"nixio".bin
fs=require"nixio.fs"
sys=require"luci.sys"
uci=require"luci.model.uci".cursor()
util=require"luci.util"
datatypes=require"luci.cbi.datatypes"
jsonc=require"luci.jsonc"
i18n=require"luci.i18n"
appname="coredns"
curl_args={"-skfL","--connect-timeout 3","--retry 3","-m 60"}
command_timeout=300
LEDE_BOARD=nil
DISTRIB_TARGET=nil
LOG_FILE=uci:get("coredns","global","logfile")
function log(...)
local a=os.date("%Y-%m-%d %H:%M:%S: ")..table.concat({...}," ")
local e,t=io.open(LOG_FILE,"a")
if e and t==nil then
e:write(a.."\n")
e:close()
end
end
function exec_call(e)
local a=io.popen(e..'; echo -e "\n$?"')
local e={}
local t=""
local o
for t in a:lines()do
e[#e+1]=t
end
a:close()
if#e>0 then
o=e[#e]
for a=1,#e-1 do
t=t..e[a]..((a==#e-1)and""or"\n")
end
end
return tonumber(o),trim(t)
end
function curl_base(a,t,e)
if not e then e={}end
if t then
e[#e+1]="-o "..t
end
local e=string.format('curl %s "%s"',table_join(e),a)
return exec_call(e)
end
function curl_logic(a,e,t)
return_code,result=curl_base(a,e,t)
return return_code,result
end
function table_join(a,e)
if not e then
e=" "
end
local t=""
for o,i in ipairs(a)do
t=t..a[o]..(o==#a and""or e)
end
return t
end
function url(...)
local e=string.format("admin/services/%s",appname)
local t={...}
for a,t in pairs(t)do
if t~=""then
e=e.."/"..t
end
end
return require"luci.dispatcher".build_url(e)
end
function trim(e)
return(e:gsub("^%s*(.-)%s*$","%1"))
end
function is_exist(e,t)
for a,e in ipairs(e)do
if e==t then
return true
end
end
return false
end
function repeat_exist(t,a)
local e=0
for o,t in ipairs(t)do
if t:find("-")and t==a then
e=e+1
end
end
if e>1 then
return true
end
return false
end
function get_args(e)
local a={}
for t,o in pairs(e)do
if t>0 then
local t=e[t+1]
if t then
if repeat_exist(e,t)==false then
a[o]=t
end
end
end
end
return a
end
function get_function_args(e)
local a=nil
if e and#e>1 then
local t={}
for o=2,#e do
t[#t+1]=e[o]
end
a=get_args(t)
end
return a
end
function strToTable(e)
if e==nil or type(e)~="string"then
return{}
end
return loadstring("return "..e)()
end
function is_ip(e)
if is_ipv6(e)then
e=get_ipv6_only(e)
end
return datatypes.ipaddr(e)
end
function is_ipv6(t)
local e=t
local t=t:match('%[(.*)%]')
if t then
e=t
end
if datatypes.ip6addr(e)then
return true
end
return false
end
function is_ipv6addrport(e)
if is_ipv6(e)then
local t,e=e:match('%[(.*)%]:([^:]+)$')
if e then
return datatypes.port(e)
end
end
return false
end
function get_ipv6_only(e)
local t=""
if is_ipv6(e)then
t=e
if e:match('%[(.*)%]')then
t=e:match('%[(.*)%]')
end
end
return t
end
function get_ipv6_full(t)
local e=""
if is_ipv6(t)then
e=t
if not t:match('%[(.*)%]')then
e="["..e.."]"
end
end
return e
end
function get_ip_type(e)
if is_ipv6(e)then
return"6"
elseif datatypes.ip4addr(e)then
return"4"
end
return""
end
function is_mac(e)
return datatypes.macaddr(e)
end
function ip_or_mac(e)
if e then
if get_ip_type(e)=="4"then
return"ip"
end
if is_mac(e)then
return"mac"
end
end
return""
end
function iprange(e)
if e then
local t,e=e:match("^([^/]+)-([^/]+)$")
if(t and datatypes.ip4addr(t))and(e and datatypes.ip4addr(e))then
return true
end
end
return false
end
function get_domain_from_url(t)
local e=string.match(t,"//([^/]+)")
if e then
return e
end
return t
end
function gen_uuid(t)
local e=sys.exec("echo -n $(cat /proc/sys/kernel/random/uuid)")
if t==nil then
e=string.gsub(e,"-","")
end
return e
end
function gen_short_uuid()
return sys.exec("echo -n $(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 8)")
end
function uci_get_type(t,a,e)
local t=uci:get_first(appname,t,a,e)or sys.exec("echo -n $(uci -q get "..appname..".@"..t.."[0]."..a..")")
if(t==nil or t=="")and(e and e~="")then
t=e
end
return t
end
function uci_get_type_id(t,a,e)
local t=uci:get(appname,t,a,e)or sys.exec("echo -n $(uci -q get "..appname.."."..t.."."..a..")")
if(t==nil or t=="")and(e and e~="")then
t=e
end
return t
end
function chmod_755(e)
if e and e~=""then
if not fs.access(e,"rwx","rx","rx")then
fs.chmod(e,755)
end
end
end
function is_finded(e)
return luci.sys.exec('type -t -p "/usr/share/coredns" "%s"'%{e})~=""and true or false
end
function is_file(e)
if e and#e>1 then
if sys.exec('[ -f "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
function is_dir(e)
if e and#e>1 then
if sys.exec('[ -d "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
function get_final_dir(e)
if is_dir(e)then
return e
else
return get_final_dir(fs.dirname(e))
end
end
function get_free_space(e)
if e==nil then e="/"end
if sys.call("df -k "..e.." >/dev/null 2>&1")==0 then
return tonumber(sys.exec("echo -n $(df -k "..e.." | awk 'NR>1' | awk '{print $4}')"))
end
return 0
end
function get_file_space(e)
if e==nil then return 0 end
if fs.access(e)then
return tonumber(sys.exec("echo -n $(du -k "..e.." | awk '{print $1}')"))
end
return 0
end
function auto_get_arch()
local e=nixio.uname().machine or""
if fs.access("/usr/lib/os-release")then
LEDE_BOARD=sys.exec("echo -n $(grep 'LEDE_BOARD' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
end
if fs.access("/etc/openwrt_release")then
DISTRIB_TARGET=sys.exec("echo -n $(grep 'DISTRIB_TARGET' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}')")
end
if e=="mips"then
if LEDE_BOARD and LEDE_BOARD~=""then
if string.match(LEDE_BOARD,"ramips")=="ramips"then
e="ramips"
else
e=sys.exec("echo '"..LEDE_BOARD.."' | grep -oE 'ramips|ar71xx'")
end
elseif DISTRIB_TARGET and DISTRIB_TARGET~=""then
if string.match(DISTRIB_TARGET,"ramips")=="ramips"then
e="ramips"
else
e=sys.exec("echo '"..DISTRIB_TARGET.."' | grep -oE 'ramips|ar71xx'")
end
end
end
return util.trim(e)
end
